import parser.*; //Package aus Parser.jar enthält die Klasse Parser und die Methode rechne(..)
import uiplotter.*; // FT-Plotter am Universal-Interface + Slave -> über LPT1 verbunden!
import ch.aplu.turtle.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
 /* Parser erzeugt aus dem Funktionsterm einen binären Termbaum. 
 * Der Termstring darf alle gängigen mathematischen Operatoren sowie Klammern () enthalten.
 * Für Potenzieren wird ^ verwendet. Die Funktionen sin, cos, tan, log und sqrt sind möglich.
 * Es können Kommazahlen, die Zahl e, die Variable x und eventuell der Parameter a verwendet werden.
 * Beispiel: "2^x*(a+1)+sin(x^2)"
 * Leerzeichen im String sind nicht zulässig.
 * Neue Terme können im Textfeld eingegeben werden. 
 * Neben dem Term können die Grenzen xmin, xmax, ymin und ymax eingegeben werden.
 * Mögliche Methoden sind zeige() zur Kontrolle des Termbaums, rechne (double x) bzw.
 * rechne (double x, double a), falls der Parameter a vorkommt.
 * 
 * ftPlotter liefert die FT-Plotterbefehle moveto, lineto, pu und pd.
 * 
 * maleGraph() zeichnet einen neuen Graph in das vorhandene Koordinatensystem.
 * save() speichert das Bild in die Datei bild.png.
 * 
 * Bevor das Koordinatensystem geplottet wird, leuchtet eine rote Lampe. 
 * Bevor ein Graph geplottet wird, leuchtet eine gelbe Lampe.
 * Jetzt kann der Malstift getauscht werden.  
 * Durch Drücken des Tasters 6 (oder ESC) startet der Malvorgang.
 *
 * @author (Jawtusch) 
 * @version (1.10.2017)
 */

public class ParserPlotter implements ActionListener {
     
    class List{
    double x;
    double y;
}

    ftPlotter ftp;
    JFrame applikation;
    Container container;
     
    // Menüleiste
    JMenuBar menueLeiste;
  
    // Menüleiste Elemente
    JMenu datei;
    JMenu hilfe;
    JMenu ftPlotter;
    JMenu fischertechnik;
     
    // Aktionen
    JMenuItem zeigeTermbaum;
    JMenuItem koordinatensystem;
    JMenuItem nurGraph;
    JMenuItem speichern;
    JMenuItem loeschen;
    JMenuItem ft_Plotter;
    JMenuItem ftGraph;
    JMenuItem ftKoordinatensystem;
    JMenuItem ft_Plotter_aus;
     
    // Info
    JMenuItem faq;
    JMenuItem about;
    Turtle t;
    Playground pg = new Playground();
    
    String funktionsTerm = "0,5*x"; //"x*(x+1)*(x-a)";
    Parser p ; 
    double xmin = -5, xmax = 5, ymin = -2.92, ymax = 2.92, h= 420, w=680, dx, dy;
    FrameMain window;
    JTextField eingabeFeld;
    JPanel panel;
    String[] stiftfarben = {"BLACK", "BLUE", "CYAN", "GREEN", "GRAY" , "MAGENTA", "ORANGE", "PINK", "RED"}; //"LIGHT_GRAY", "WHITE", "YELLOW"
    int pc= 1; 
    String[] wahl = {"","","","",""};
   ArrayList<Integer> xachse0 = new ArrayList<Integer>();
   ArrayList<Integer> yachse0 = new ArrayList<Integer>();
   ArrayList<Integer> xachse = new ArrayList<Integer>();
   ArrayList<Integer> yachse = new ArrayList<Integer>();
   
//  private JavaFish ui = new JavaFish();
  int stepperdelay = 12; // ca. 11ms Verzögerung 
  int ftpx = 0, ftpy = 0;
  int stiftNr = 9;
  boolean ftplot = false, roboaktiv = false, skala = false;
boolean firstx , firsty ;  
double xpos, ypos;
    int px = 0, py = 0;
String[] info = { 
 "Der Termstring darf alle gängigen mathematischen Operatoren sowie Klammern ()",
 "enthalten.",
 "Für Potenzieren wird ^ verwendet. Die Funktionen sin, cos, tan, log und sqrt",
 "sind möglich.",
 "Für die Multiplikation bzw. Division muss * bzw. / verwendet werden ",
 "Es können Kommazahlen, die Zahl e, die Variable x und eventuell der Parameter",
 "a verwendet werden. Minus-Vorzeichen muss mit ~ geschreiben werden z.B. ~0,25",
 "Term-Beispiel: 2^x*(a+1,5)+sin(x^~2)",
 "Leerzeichen im String sind nicht zulässig.",
 "Neue Terme können im Textfeld eingegeben werden.", 
 "Mögliche Methoden sind zeige() zur Kontrolle des Termbaums, rechne (double x)",
 "bzw. rechne (double x,double a) berechnet Funktionswerte.",
 " ", 
 "Mit 'Koordinatensystem mit Graph' können neben dem Term noch Werte für xmin,",
 "xmax, ymin und ymax festgelegt werden.",
 "Stehen hinter dem Term keine Zahlen, dann werden die Grenzen -5, 5, -2.92, ",
 "2.92 verwendet.",
 "male Graph zeichnet einen neuen Graph in das vorhandene Koordinatensystem.",
 "speichere Bild speichert das Bild als png-File."
};
         
         
 public ParserPlotter() {
      t = new Turtle(new TurtleFrame("Funktionsplotter",680, 420)); 
     pg = t.getPlayground(); 
     
     JFrame applikation;
       //   applikation = new JFrame("JMenuBar Beispiel");
       applikation = t.getFrame(); 
      
       applikation.addWindowListener(new WindowAdapter() {

        @Override
        public void windowClosing(WindowEvent e) {
          if (ftplot) ftp.close();  
           System.exit(0);
        }
      });
       
          container = applikation.getContentPane();
          
          // Menüleiste erzeugen
          menueLeiste = new JMenuBar();
          
          // Menüelemente erzeugen
          datei = new JMenu("Aktion");
          hilfe = new JMenu("Info");
          ftPlotter = new JMenu("FT-Plotter"); 
          fischertechnik = new JMenu("ft -> verbunden"); 
          
          // Untermenüelemente erzeugen
          zeigeTermbaum = new JMenuItem("zeige Termbaum");
          zeigeTermbaum.addActionListener(this);
          koordinatensystem = new JMenuItem("Koordinatensystem mit Graph");
          koordinatensystem.addActionListener(this);
          nurGraph = new JMenuItem("male Graph");
          nurGraph.addActionListener(this);
          speichern = new JMenuItem("speichere Bild");
          speichern.addActionListener(this);
          loeschen = new JMenuItem("lösche Bild");
          loeschen.addActionListener(this);
          ft_Plotter = new JMenuItem("FT-Plotter an");
          ft_Plotter.addActionListener(this);
          ft_Plotter_aus = new JMenuItem("FT-Plotter aus");
          ft_Plotter_aus.addActionListener(this);
          ftKoordinatensystem = new JMenuItem("FT-Plot: Koordinatensystem");
          ftKoordinatensystem.addActionListener(this);
          ftGraph = new JMenuItem("FT-Plot: Graph");
          ftGraph.addActionListener(this);
          
          faq = new JMenuItem("Benutzerhinweise");
          faq.addActionListener(this);
          about = new JMenuItem("Hinweise zu Parser.jar");
          about.addActionListener(this);
          
          // Menüelemente hinzufügen
          menueLeiste.add(datei);
          menueLeiste.add(hilfe);
          menueLeiste.add(ftPlotter);
          menueLeiste.add(fischertechnik);
          ftPlotter.setVisible(false); 
          fischertechnik.setVisible(false);          
          // Untermenüelemente hinzufügen
          datei.add(zeigeTermbaum);
          datei.add(koordinatensystem);
          datei.add(nurGraph);
          datei.add(speichern);
          datei.add(loeschen);
          datei.add(ft_Plotter);
          
          hilfe.add(faq);
          hilfe.add(about);
          
          ftPlotter.add(ftKoordinatensystem);
          ftPlotter.add(ftGraph);
          ftPlotter.add(ft_Plotter_aus);
          // Textfeld erzeugen
        //  textarea = new JTextArea();          
          
          applikation.add(menueLeiste, BorderLayout.NORTH);
       //   applikation.add(new JScrollPane(textarea), BorderLayout.CENTER);

        //  applikation.setSize(400, 300);
        //  applikation.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
          applikation.setVisible(true);

       panel = new JPanel(new BorderLayout());
       p = new Parser(funktionsTerm); // Dies erzeugt den Termbaum
    
       eingabeFeld = new JTextField(3);
       panel.add(eingabeFeld);
       applikation.add(panel,BorderLayout.SOUTH);
       SwingUtilities.updateComponentTreeUI(t.getFrame());
       eingabeFeld.requestFocus();
       eingabeFeld.setText(funktionsTerm);
       window = new FrameMain();
   eingabeFeld.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
         String eingabe = eingabeFeld.getText();
         wahl = eingabe.split(" ");   
         funktionsTerm = wahl[0];
         p = new Parser(funktionsTerm);
        }
     });   
  }
     
 public class FrameMain extends javax.swing.JFrame { // mit toggleVisible() kann der Fokus auf das Turtle-Fenster gesetzt werden!

  private final javax.swing.JFrame mainFrame = t.getFrame();

  private void toggleVisible() {
    Robot robot;
    setVisible(!isVisible());
    if (isVisible()) {
      toFront();
      requestFocus();
      setAlwaysOnTop(true);
      try {
        //remember the last location of mouse
        final Point oldMouseLocation = MouseInfo.getPointerInfo().getLocation();

        //simulate a mouse click on title bar of window
        robot = new Robot();
        robot.mouseMove(mainFrame.getX() + 100, mainFrame.getY() + 5);
        robot.mousePress(InputEvent.BUTTON1_DOWN_MASK);
        robot.mouseRelease(InputEvent.BUTTON1_DOWN_MASK);

        //move mouse to old location
        robot.mouseMove((int) oldMouseLocation.getX(), (int) oldMouseLocation.getY());
      } catch (Exception ex) {
        //just ignore exception, or you can handle it as you want
      } finally {
        setAlwaysOnTop(false);
      }
    }
  }
}     
 
     public void actionPerformed(ActionEvent object) {
          if (object.getSource() == zeigeTermbaum){
               zeige();
          }
          if (object.getSource() == koordinatensystem){
               main1();
          }
          if (object.getSource() == nurGraph){
              t.getFrame().requestFocus(); maleGraph();
          }
          if (object.getSource() == faq){
              System.out.print('\u000C');
               information();
          }
          if (object.getSource() == about){
            //System.out.print('\u000C');
            for (int j=0; j<50;j++) System.out.println("");
                    String[] basis = {
                    "Dynamische Datenstruktur für binäre Bäume (aus Parser.jar):", " ",
                    "class Str  {public String s; }",  
                    "class Node {private Node left; private Str value; private Node right; …}",
                    "class Tree {private Node root; public Tree() {root = null;}",
                    "void newTree(Tree left, Str v, Tree right) {",
                    "   root = new Node(left.root, v, right.root);}…}"," ",
                "Parser(String Term) erzeugt aus dem Funktionsterm einen binären Termbaum."}; 
                    for (String str: basis) {System.out.println(str);}
          }
          if (object.getSource() == speichern){
            
             boolean ret = save(); 
            
             window.toggleVisible(); window.setVisible(false); 
          }
          if (object.getSource() == loeschen){
             panel.setVisible(false); t.getFrame().revalidate(); 
             clean();  
             panel.setVisible(true); t.getFrame().revalidate();
             window.toggleVisible(); window.setVisible(false);
          }
       if (object.getSource() == ft_Plotter){
         ftplotteran();
       }
       if (object.getSource() == ft_Plotter_aus){
          if (ftplot) {ftp.close(); ftplot = false; 
              ftPlotter.setVisible(false); //t.getFrame().revalidate();
          } 
       }
       if (object.getSource() == ftKoordinatensystem){
          if (ftplot) { 
              plotteKoordinatensystem();
          } 
       }
       if (object.getSource() == ftGraph){
          if (ftplot) {plotteGraph();
          } 
       }
    }
    
    public void ftplotteran(){
       if (!ftplot) {
          try {ftplot = true; ftp = new ftPlotter(stepperdelay); 
              ftp.home();
              ftp.setLamp(12,true); ftp.pause(200);ftp.setLamp(12,false);}
          catch (RuntimeException e) {  // FishFaceException
              ftplot = false;
              System.out.println(e.getMessage());
          }
       }
       if (ftplot) { 
          ftp.home(); 
          ftPlotter.setVisible(true); 
//        t.getFrame().revalidate();
       }
    }
 private int ftxp(double x) {
    return (int)Math.round(w*(x-xmin) / (xmax-xmin)) ;
 }
 private int ftyp(double y) {
    return (int)Math.round(h*(y-ymin) / (ymax-ymin)) ;
 }     
 private double xp(double x) {
    return w*(x-xmin) / (xmax-xmin) - 340;
 }
 private double yp(double y) {
    return h*(y-ymin) / (ymax-ymin) - 210;
 }

 public boolean save() {
  GBitmap gb = new GBitmap(680,420);  
  BufferedImage outImg = t.getPlayground().getTraceBuffer();   
  return gb.save(outImg,"bild.png","png");
 } 
 
 public void information(){
    for (int j=0; j<50;j++) System.out.println("");
    for (String str: info) {System.out.println(str);}
 }
    
 public void main1() {
    if (wahl.length == 5 && wahl[1] != "") {
     main2(Double.parseDouble(wahl[1]),Double.parseDouble(wahl[2]),Double.parseDouble(wahl[3]),Double.parseDouble(wahl[4]));
    }    
    else main2 (-5,5,-2.92,2.92);
    skala = true;
 }
 private void main2 (double a, double b, double c, double d) {
 xachse0.clear(); xachse.clear(); yachse0.clear(); yachse.clear();
       xmin = a; xmax = b; ymin = c; ymax = d;  
      // h=420; w = 680; 

       firstx = true; firsty = true;
       dx = xp(1) - xp(0); dy = yp(1) - yp(0);
       t.ht(); t.setPos(xp(0), yp(0)); 
       t.pd();
       t.setPenColor("BLACK");
       t.setPenWidth(2);
       t.setH(180); 
   
     while (t.getY() > -h/2 ) {t.fd(dy); t.rt(90); t.fd(5); t.bk(10); t.fd(5); t.lt(90); 
        yachse0.add((int)t.getY()+210);}
        for(int j=yachse0.size()-1; j>=0;j--) {yachse.add(yachse0.get(j));}
       t.setPos(xp(0), yp(0)); t.setH(0);
     while (t.getY() < h/2 ) {t.fd(dy); t.rt(90); t.fd(5); t.bk(10); 
           if (firsty) {xpos = t.getX(); t.setX(xpos - 15) ; t.label("1"); firsty = false; t.setX(xpos);}  
           t.fd(5); t.lt(90); yachse.add((int)t.getY()+210);}
          t.setPos(xp(0), yp(0)); t.setH(270);
     while (t.getX() > -w/2) {t.fd(dx); t.rt(90); t.fd(5); t.bk(10); 
         t.fd(5); t.lt(90); xachse0.add((int)t.getX()+340);}
      t.setPos(xp(0), yp(0)); t.setH(90);
        for(int j=xachse0.size()-1; j>=0;j--) {xachse.add(xachse0.get(j));}    
     while (t.getX() < w/2) {t.fd(dx); t.rt(90); t.fd(5); 
           if (firstx) {ypos = t.getY(); t.setY(ypos - 20) ; t.label("1"); firstx = false; t.setY(ypos);}  
           t.bk(10); t.fd(5); t.lt(90);
           xachse.add((int)t.getX()+340);}

       t.lt(90); 
       t.setPenWidth(1);
       maleGraph();
 }
 
 public void plotteKoordinatensystem() {
   if (ftplot) {
        while (!ftp.finish(6)) {ftp.setLamp(10,true);}
        ftp.setLamp(10,false);
        if (!skala) main1();
        int ox = (int)ftxp(0); int oy = (int)ftyp(0);
        ftp.moveto(0, oy); ftp.pd(stiftNr); 
         for (Integer xWert: xachse) {
             ftp.lineto(xWert,oy); ftp.lineto(xWert,oy - 7); ftp.lineto(xWert,oy);}
        //ftp.lineto(680,(int)ftyp(0));
        ftp.pu(stiftNr);
        ftp.moveto(ox, 0); ftp.pd(stiftNr); 
        //ftp.lineto((int)ftxp(0),420);
        for (Integer yWert: yachse) {
            ftp.lineto(ox,yWert); ftp.lineto(ox - 6,yWert);ftp.lineto(ox,yWert);}
        ftp.pu(stiftNr);
   }
 }
 public void maleGraph() {
    double x = xmin;
    double ai = 1;
    t.ht();
    String replaceString=funktionsTerm.replace("tan","");
       if (replaceString.contains("a")) {
           for (int j = 1; j < 4; j++) 
           graph(x,ai*j); }
       else graph(x,ai);
    window.toggleVisible(); window.setVisible(false); // setze den Fokus auf das Eingabefeld im Turtlewindow
    eingabeFeld.requestFocus();
 }  
 public void plotteGraph() {
    double x = xmin;
    double ai = 1;
    t.ht();
    String replaceString=funktionsTerm.replace("tan","");
       if (replaceString.contains("a")) {
           for (int j = 1; j < 4; j++) 
           ftgraph(x ,(xmax-xmin) / 680, ai*j);
        }
       else ftgraph(x,(xmax-xmin) / 340, ai);
 }  
private void ftgraph(double x, double d, double a) {     
      double px, py, y; //t.st();
      int ftx, fty ;
      boolean penup = true;
      if (ftplot) {
        while (!ftp.finish(6)) {ftp.setLamp(11,true);}
        ftp.setLamp(11,false);}
      while (x < xmax) { y = rechne(x,a); ftx=ftxp(x); fty =  ftyp(y); 
          if (fty < 0 || fty > 420 || fty == ftyp(0)) {
              penup = true; if (ftplot) {ftp.pu(stiftNr);}} 
          else {if (penup) {
              if (ftplot && fty < 420 && fty > 0) {ftp.moveto(ftx,fty); ftp.pd(stiftNr);
              penup = false; }}}
          if (ftplot && fty < 420 && fty > 0) {ftp.lineto(ftx,fty);
          }
        x = x+d; 
      }
      if (ftplot) {ftp.pu(stiftNr);}
}
 public void clean() {
    t.clean();
     window.toggleVisible(); window.setVisible(false);
 }

  private void graph(double x, double a) {
    t.setPos(xp(x), yp(rechne(x,a)));
    zeichneGraph(x ,(xmax-xmin) / 680, a);
  }
    
  private void zeichneGraph(double x, double d, double a) {
      double px, py, y; //t.st();
      int ftx, fty ;
      boolean penup = true;
      t.setPenColor(stiftfarben[pc]); 
      if (pc < 8) pc++; else pc = 1;
      while (x < xmax) { px = xp(x); y = rechne(x,a); py =  yp(y);  
          if (py < -210 || py > 210 || py == yp(0) ) {
              t.pu();penup = true; } 
          else {if (penup) {t.setPos(px,py); t.pd(); 
              penup = false; }}
          t.setH(t.towards(px,py)); t.fd(t.distance(px,py));
          x = x+d; 
      }
      t.setH(0);
  }
       
    /**
    * @param  x    x-Wert
    * @return      Funktionswert f(x)
    */
    public double rechne(double x)
    {
        // rechne(..) berechnet mit Hilfe des Binärbaums Funktionswerte.
       return p.rechne(x);   
    }
    
    public double rechne(double x, double a)
    {
        return p.rechne(x,a);
    }
    public void zeige(){
       p.zeige();} 

    public static void main(String[] args) {
          new ParserPlotter();
    }
}
